WeblogicTOPLinkDeploymentTool (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional.ejb, class: WeblogicTOPLinkDeploymentTool

# Class WeblogicTOPLinkDeploymentTool

java.lang.Object
org.apache.tools.ant.taskdefs.optional.ejb.GenericDeploymentTool
org.apache.tools.ant.taskdefs.optional.ejb.WeblogicDeploymentTool
org.apache.tools.ant.taskdefs.optional.ejb.WeblogicTOPLinkDeploymentTool

All Implemented Interfaces:
  `EJBDeploymentTool`

public class WeblogicTOPLinkDeploymentTool extends WeblogicDeploymentTool
Deployment tool for WebLogic TOPLink.

- ## Field Summary

  ### Fields inherited from class WeblogicDeploymentTool

  `COMPILER_EJB11, COMPILER_EJB20, DEFAULT_COMPILER, DEFAULT_WL51_DTD_LOCATION, DEFAULT_WL51_EJB11_DTD_LOCATION, DEFAULT_WL60_51_DTD_LOCATION, DEFAULT_WL60_DTD_LOCATION, DEFAULT_WL60_EJB11_DTD_LOCATION, DEFAULT_WL60_EJB20_DTD_LOCATION, DEFAULT_WL70_DTD_LOCATION, PUBLICID_EJB11, PUBLICID_EJB20, PUBLICID_WEBLOGIC_EJB510, PUBLICID_WEBLOGIC_EJB600, PUBLICID_WEBLOGIC_EJB700, WL_CMP_DD, WL_DD`
  Modifier and Type
  Field
  Description
  `protected static final String`
  `COMPILER_EJB11`
  `protected static final String`
  `COMPILER_EJB20`
  `protected static final String`
  `DEFAULT_COMPILER`
  `protected static final String`
  `DEFAULT_WL51_DTD_LOCATION`
  `protected static final String`
  `DEFAULT_WL51_EJB11_DTD_LOCATION`
  WebLogic 5.1 dtd location
  `protected static final String`
  `DEFAULT_WL60_51_DTD_LOCATION`
  `protected static final String`
  `DEFAULT_WL60_DTD_LOCATION`
  `protected static final String`
  `DEFAULT_WL60_EJB11_DTD_LOCATION`
  WebLogic 6.0 ejb 1.1 dtd location
  `protected static final String`
  `DEFAULT_WL60_EJB20_DTD_LOCATION`
  WebLogic 6.0 ejb 2.0 dtd location
  `protected static final String`
  `DEFAULT_WL70_DTD_LOCATION`
  `static final String`
  `PUBLICID_EJB11`
  EJB11 id
  `static final String`
  `PUBLICID_EJB20`
  EJB20 id
  `static final String`
  `PUBLICID_WEBLOGIC_EJB510`
  WebLogic 5.1.0 id
  `static final String`
  `PUBLICID_WEBLOGIC_EJB600`
  WebLogic 6.0.0 id
  `static final String`
  `PUBLICID_WEBLOGIC_EJB700`
  WebLogic 7.0.0 id
  `protected static final String`
  `WL_CMP_DD`
  `protected static final String`
  `WL_DD`

  ### Fields inherited from class GenericDeploymentTool

  `ANALYZER_CLASS_FULL, ANALYZER_CLASS_SUPER, ANALYZER_FULL, ANALYZER_NONE, ANALYZER_SUPER, DEFAULT_ANALYZER, DEFAULT_BUFFER_SIZE, EJB_DD, JAR_COMPRESS_LEVEL, MANIFEST, META_DIR`
  Modifier and Type
  Field
  Description
  `static final String`
  `ANALYZER_CLASS_FULL`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_CLASS_SUPER`
  The analyzer class for the super analyzer
  `static final String`
  `ANALYZER_FULL`
  A dependency analyzer name to find all related classes
  `static final String`
  `ANALYZER_NONE`
  A dependency analyzer name for no analyzer
  `static final String`
  `ANALYZER_SUPER`
  A dependency analyzer name to find ancestor classes
  `static final String`
  `DEFAULT_ANALYZER`
  The default analyzer
  `static final int`
  `DEFAULT_BUFFER_SIZE`
  The default buffer byte size to use for IO
  `protected static final String`
  `EJB_DD`
  Name for EJB Deployment descriptor within EJB jars
  `static final int`
  `JAR_COMPRESS_LEVEL`
  The level to use for compression
  `protected static final String`
  `MANIFEST`
  The standard MANIFEST file
  `protected static final String`
  `META_DIR`
  The standard META-INF directory in jar files

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `WeblogicTOPLinkDeploymentTool()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)`
  Add any vendor specific files which should be included in the EJB Jar.
  `protected DescriptorHandler`
  `getDescriptorHandler(File srcDir)`
  Get the descriptor handler.
  `void`
  `setToplinkdescriptor(String inString)`
  Setter used to store the name of the toplink descriptor.
  `void`
  `setToplinkdtd(String inString)`
  Setter used to store the location of the toplink DTD file.
  `void`
  `validateConfigured()`
  Called to validate that the tool parameters have been configured.

  ### Methods inherited from class WeblogicDeploymentTool

  `addSysproperty, createWLClasspath, getClassLoaderFromJar, getEjbcClass, getJvmDebugLevel, getWeblogicDescriptorHandler, isRebuildRequired, registerKnownDTDs, setArgs, setCompiler, setEjbcClass, setEJBdtd, setJvmargs, setJvmDebugLevel, setKeepgenerated, setKeepgeneric, setNewCMP, setNoEJBC, setOldCMP, setOutputDir, setRebuild, setSuffix, setWeblogicdtd, setWLClasspath, setWLdtd, writeJar`
  Modifier and Type
  Method
  Description
  `void`
  `addSysproperty(Environment.Variable sysp)`
  Add a nested sysproperty element.
  `Path`
  `createWLClasspath()`
  Get the classpath to the WebLogic classpaths.
  `protected ClassLoader`
  `getClassLoaderFromJar(File classjar)`
  Helper method invoked by isRebuildRequired to get a ClassLoader for a Jar File passed to it.
  `String`
  `getEjbcClass()`
  Get the ejbc compiler class.
  `Integer`
  `getJvmDebugLevel()`
  Get the debug level.
  `protected DescriptorHandler`
  `getWeblogicDescriptorHandler(File srcDir)`
  Get the WebLogic descriptor handler.
  `protected boolean`
  `isRebuildRequired(File genericJarFile, File weblogicJarFile)`
  Helper method to check to see if a WebLogic EJB 1.1 jar needs to be rebuilt using ejbc.
  `protected void`
  `registerKnownDTDs(DescriptorHandler handler)`
  Register the DTDs.
  `void`
  `setArgs(String args)`
  Any optional extra arguments pass to the weblogic.ejbc tool.
  `void`
  `setCompiler(String compiler)`
  The compiler (switch `-compiler`) to use; optional.
  `void`
  `setEjbcClass(String ejbcClass)`
  Set the classname of the ejbc compiler; optional Normally ejbjar determines the appropriate class based on the DTD used for the EJB.
  `void`
  `setEJBdtd(String inString)`
  Deprecated.
  `void`
  `setJvmargs(String args)`
  Set any additional arguments to pass to the WebLogic JVM; optional.
  `void`
  `setJvmDebugLevel(Integer jvmDebugLevel)`
  Sets the weblogic.StdoutSeverityLevel to use when running the JVM that executes ejbc; optional.
  `void`
  `setKeepgenerated(String inValue)`
  Controls whether WebLogic will keep the generated Java files used to build the class files added to the jar.
  `void`
  `setKeepgeneric(boolean inValue)`
  controls whether the generic file used as input to ejbc is retained; defaults to false
  `void`
  `setNewCMP(boolean newCMP)`
  If this is set to true, the new method for locating CMP descriptors will be used; optional, default false.
  `void`
  `setNoEJBC(boolean noEJBC)`
  Do not EJBC the jar after it has been put together; optional, default false
  `void`
  `setOldCMP(boolean oldCMP)`
  Set the value of the oldCMP scheme.
  `void`
  `setOutputDir(File outputDir)`
  If set ejbc will use this directory as the output destination rather than a jar file.
  `void`
  `setRebuild(boolean rebuild)`
  Set the rebuild flag to false to only update changes in the jar rather than rerunning ejbc; optional, default true.
  `void`
  `setSuffix(String inString)`
  Setter used to store the suffix for the generated WebLogic jar file.
  `void`
  `setWeblogicdtd(String inString)`
  Deprecated.
  `void`
  `setWLClasspath(Path wlClasspath)`
  Optional classpath to WL6.0.
  `void`
  `setWLdtd(String inString)`
  Deprecated.
  `protected void`
  `writeJar(String baseName, File jarFile, Hashtable<String,File> files, String publicId)`
  Method used to encapsulate the writing of the JAR file.

  ### Methods inherited from class GenericDeploymentTool

  `addFileToJar, addSupportClasses, checkAndAddDependants, checkConfiguration, configure, createClasspath, getClassLoaderForBuild, getCombinedClasspath, getConfig, getDestDir, getJarBaseName, getLocation, getManifestFile, getPublicId, getTask, getVendorDDPrefix, log, needToRebuild, parseEjbFiles, processDescriptor, setClasspath, setDestdir, setGenericJarSuffix, setTask, usingBaseJarName`
  Modifier and Type
  Method
  Description
  `protected void`
  `addFileToJar(JarOutputStream jStream, File inputFile, String logicalFilename)`
  Utility method that encapsulates the logic of adding a file entry to a .jar file.
  `protected void`
  `addSupportClasses(Hashtable<String,File> ejbFiles)`
  Adds any classes the user specifies using support nested elements to the `ejbFiles` Hashtable.
  `protected void`
  `checkAndAddDependants(Hashtable<String,File> checkEntries)`
  Add all available classes, that depend on Remote, Home, Bean, PK
  `protected void`
  `checkConfiguration(String descriptorFileName, SAXParser saxParser)`
  This method is called as the first step in the processDescriptor method to allow vendor-specific subclasses to validate the task configuration prior to processing the descriptor.
  `void`
  `configure(org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config config)`
  Configure this tool for use in the ejbjar task.
  `Path`
  `createClasspath()`
  Add the classpath for the user classes
  `protected ClassLoader`
  `getClassLoaderForBuild()`
  Returns a Classloader object which parses the passed in generic EjbJar classpath.
  `protected Path`
  `getCombinedClasspath()`
  Get the classpath by combining the one from the surrounding task, if any and the one from this tool.
  `protected org.apache.tools.ant.taskdefs.optional.ejb.EjbJar.Config`
  `getConfig()`
  Get the basename terminator.
  `protected File`
  `getDestDir()`
  Get the destination directory.
  `protected String`
  `getJarBaseName(String descriptorFileName)`
  Using the EJB descriptor file name passed from the `ejbjar` task, this method returns the "basename" which will be used to name the completed JAR file.
  `protected Location`
  `getLocation()`
  Get the build file location associated with this element's task.
  `protected File`
  `getManifestFile(String prefix)`
  Get the manifest file to use for building the generic jar.
  `protected String`
  `getPublicId()`
  Returns the Public ID of the DTD specified in the EJB descriptor.
  `protected Task`
  `getTask()`
  Get the task for this tool.
  `String`
  `getVendorDDPrefix(String baseName, String descriptorFileName)`
  Get the prefix for vendor deployment descriptors.
  `protected void`
  `log(String message, int level)`
  Log a message to the Ant output.
  `protected boolean`
  `needToRebuild(Hashtable<String,File> ejbFiles, File jarFile)`
  This method checks the timestamp on each file listed in the `ejbFiles` and compares them to the timestamp on the `jarFile` .
  `protected Hashtable<String,File>`
  `parseEjbFiles(String descriptorFileName, SAXParser saxParser)`
  This method returns a list of EJB files found when the specified EJB descriptor is parsed and processed.
  `void`
  `processDescriptor(String descriptorFileName, SAXParser saxParser)`
  Process a deployment descriptor, generating the necessary vendor specific deployment files.
  `void`
  `setClasspath(Path classpath)`
  Set the classpath to be used for this compilation.
  `void`
  `setDestdir(File inDir)`
  Set the destination directory; required.
  `void`
  `setGenericJarSuffix(String inString)`
  Set the suffix for the generated jar file.
  `void`
  `setTask(Task task)`
  Set the task which owns this tool
  `protected boolean`
  `usingBaseJarName()`
  Indicate if this build is using the base jar name.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### WeblogicTOPLinkDeploymentTool

    public WeblogicTOPLinkDeploymentTool()

- ## Method Details

  - ### setToplinkdescriptor

    public void setToplinkdescriptor(String inString)
    Setter used to store the name of the toplink descriptor.
    Parameters:
      `inString` - the string to use as the descriptor name.

  - ### setToplinkdtd

    public void setToplinkdtd(String inString)
    Setter used to store the location of the toplink DTD file. This is expected to be an URL (file or otherwise). If running this on NT using a file URL, the safest thing would be to not use a drive spec in the URL and make sure the file resides on the drive that ANT is running from. This will keep the setting in the build XML platform independent.
    Parameters:
      `inString` - the string to use as the DTD location.

  - ### getDescriptorHandler

    protected DescriptorHandler getDescriptorHandler(File srcDir)
    Get the descriptor handler.
    Overrides:
      `getDescriptorHandler` in class `GenericDeploymentTool`
    Parameters:
      `srcDir` - the source file.
    Returns:
      the descriptor handler.

  - ### addVendorFiles

    protected void addVendorFiles(Hashtable<String,File> ejbFiles, String ddPrefix)
    Add any vendor specific files which should be included in the EJB Jar.
    Overrides:
      `addVendorFiles` in class `WeblogicDeploymentTool`
    Parameters:
      `ejbFiles` - the hashtable to add files to.
      `ddPrefix` - the prefix to use.

  - ### validateConfigured

    public void validateConfigured() throws BuildException
    Called to validate that the tool parameters have been configured.
    Specified by:
      `validateConfigured` in interface `EJBDeploymentTool`
    Overrides:
      `validateConfigured` in class `WeblogicDeploymentTool`
    Throws:
      `BuildException` - if there is an error.